using Domain.Entities.Forum.Boards;
using Domain.Entities.Members;
using Microsoft.EntityFrameworkCore;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Domain.Entities.Forum.Posts
{
    [Table("PostBookmark")]
    [Index(nameof(BoardID))]
    [Index(nameof(PostID))]
    [Index(nameof(MemberID))]
    [Index(nameof(PostID), nameof(MemberID), IsUnique = true)]
    [Index(nameof(BoardID), nameof(PostID), nameof(CreatedAt))]
    [Index(nameof(BoardID), nameof(MemberID), nameof(CreatedAt))]
    [Index(nameof(BoardID), nameof(PostID), nameof(MemberID), nameof(CreatedAt))]
    public class PostBookmark
    {
        [ForeignKey(nameof(BoardID))]
        public Board Board { get; set; } = null!;

        [ForeignKey(nameof(PostID))]
        public Post Post { get; set; } = null!;

        [ForeignKey(nameof(MemberID))]
        public Member Member { get; set; } = null!;

        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [DisplayName("PK")]
        [Comment("PK")]
        public int ID { get; set; }

        [DisplayName("게시판 ID")]
        [Comment("게시판 ID")]
        public int BoardID { get; set; }

        [DisplayName("게시글 ID")]
        [Comment("게시글 ID")]
        public int PostID { get; set; }

        [DisplayName("회원 ID")]
        [Comment("회원 ID")]
        public int MemberID { get; set; }

        [DisplayName("IP Address")]
        [Comment("IP Address")]
        [MaxLength(15)]
        public string? IpAddress { get; set; } = null;

        [DisplayName("User-agent")]
        [Comment("User-agent")]
        [MaxLength(255)]
        public string? UserAgent { get; set; } = null;

        [DisplayName("등록 일시")]
        [Comment("등록 일시")]
        [DataType(DataType.DateTime)]
        public DateTime CreatedAt { get; set; } = DateTime.UtcNow;
    }
}